<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services\ParaGeraisExpImpostoService;

class ParaGeraisExpImposto extends CrudWithParameterBag {

    protected $parameterBagColumns = array('CDFILIAL','NRORG');
    protected $exportPriceChartService;
    protected $dataSourceName = 'ParaGeraisExpImposto';

    public function __construct (DataSource\Manager $dataSourceManager, DataSource\ParameterBag $parameterBag, ParaGeraisExpImpostoService $expImposto) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->ParaGeraisExpImpostoService = $expImposto;
    }
    
    public function exportImpost(Request\Row $request, Response $response){
    // realiza rotina de Exportação da Tabela de Preço
        $returnData = Array(
            'STATUS' => ''
        );
        $dataExport = $request->getRow();
        $existeFilial = false;
        try {
            foreach ($dataExport['DATA']["CDFILIALDES"] as &$valor) {
                if($valor == $dataExport['DATA']["CDFILIALORI"]){
                    $existeFilial = true;
                }
            }
            
            if(!$existeFilial){
            $returnData['STATUS'] = $this->ParaGeraisExpImpostoService->exportImpost($dataExport);
            self::responseFrontEnd($response, true, $returnData);
            }
            else{ 
                throw new \Exception("A unidade de destino não pode ser igual a unidade de origem", 500);

            }
        } catch (Exception $e) {
            self::responseFrontEnd($response, false, $e);
        }
     
    }

    public function responseFrontEnd(&$response, $type, $data){
        if ($type){
            $response->addDataSet(new DataSource\DataSet($this->dataSourceName, $data));
        }
        else
            $response->setError(new Response\Error($data->getMessage(), $data->getCode()));
    }
}