<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelVendasComparativo{

    protected $utilService;
    
    public function __construct(Services\RelVendasComparativoService $relVendaCompService, Utilities\Util $utilService) {
        $this->relVendasComparativoService = $relVendaCompService;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $this->utilService->getParamsAsArray($request);
        $result = $this->relVendasComparativoService->findReport($conditions);
        $response->addDataSet(new DataSet("orm00009_vendasComparativo", $result));
        return $response;
    }
}
